<?php
//ini_set("display_errors",0);
//error_reporting(E_ALL);

defined('_JEXEC') or die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');
/**
 * abstract class for payment/shipment plugins
 *  
 * eRaty Santander Payment Plugin
 *   
 * @author SoftPill.Eu
 * @link http://www.softpill.eu
 * @copyright Copyright (c) 2012 - 2015 SoftPill.Eu. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.txt
 * This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * @version 1.0 June 2015
 */

if (!class_exists('vmPSPlugin'))
require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');


class plgVmPaymenteRatySantanderForVirtuemart extends vmPSPlugin {

	public static $_this = false;
	function __construct(& $subject, $config) {
		parent::__construct($subject, $config);
		
		$this->_loggable = TRUE;
		$this->_debug = TRUE;
		$this->tableFields = array_keys($this->getTableSQLFields());
		$this->_tablepkey = 'id';
		$this->_tableId = 'id';
		$varsToPush = array(
    'eratysantander_user' => array('', 'char'),
    'payment_logos'       => array('', 'char'),
    'countries'           => array('', 'char'),
    'cost_per_transaction'=> array('', 'int'),
    'cost_percent_total'  => array('', 'int'),
    'min_amount'          => array('', 'int'),
    'max_amount'          => array('', 'int'),
    'tax_id'              => array(0, 'int'),
    'status_pending'      => array('', 'char'),
    'status_success'      => array('', 'char'),
    'status_canceled'     => array('', 'char'));
		$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
	}
	public function getVmPluginCreateTableSQL() {
		return $this->createTableSQL('Payment eRaty Santander Table');
	}
	function getTableSQLFields() {

		$SQLfields = array(
    'id' => 'int(11) UNSIGNED NOT NULL AUTO_INCREMENT',
  	'virtuemart_order_id' => 'int(1) UNSIGNED',
  	'order_number' => 'char(64)',
  	'virtuemart_paymentmethod_id' => 'mediumint(1) UNSIGNED',
  	'payment_name' => 'varchar(5000)',
  	'payment_order_total' => 'decimal(15,5) NOT NULL',
  	'payment_currency' => 'smallint(1)',
    'payment_order_total'     => 'decimal(15,5) NOT NULL DEFAULT \'0.00000\'',
  	'cost_per_transaction' => 'decimal(10,2)',
  	'cost_percent_total' => 'decimal(10,2)',
  	'tax_id' => 'smallint(1)',
    );
  	return $SQLfields;
	}
	function setParams($param_array,$comp_name)
  {
    if ( count($param_array) > 0 )
    {
      jimport('joomla.version');
      $jver = new JVersion();
      $jversion=$jver->getShortVersion();
      $joomla_ver=2;
      if(version_compare($jversion,'2.5','<'))
      {
        $joomla_ver=1;
      }
      if($joomla_ver==1)
      {
        $db = JFactory::getDbo();
        $params1=$this->getParams($comp_name);
        foreach ( $param_array as $name => $value )
        {
          $params1[ (string) $name ] = (string) $value;
        }
        $params="";
        foreach ( $params1 as $name => $value )
        {
          $params.=$name."=".$value."\n";
        }
        $db->setQuery('UPDATE #__plugins SET params = ' .
        $db->quote( $params ) .
        ' WHERE element = '.$db->quote($comp_name));
        $db->query();
      }
      else
      {
        $db = JFactory::getDbo();
        $db->setQuery('SELECT params FROM #__extensions WHERE element = '.$db->quote($comp_name));
        $params1 = json_decode( $db->loadResult(), true );
        foreach ( $param_array as $name => $value )
        {
          $params1[ (string) $name ] = (string) $value;
        }
        $params1String = json_encode( $params1 );
        $db->setQuery('UPDATE #__extensions SET params = ' .
        $db->quote( $params1String ) .
        ' WHERE element = '.$db->quote($comp_name));
        $db->query();
      }
    }
  }
  function getParams($comp_name)
  {
    jimport('joomla.version');
    $jver = new JVersion();
    $jversion=$jver->getShortVersion();
    $joomla_ver=2;
    if(version_compare($jversion,'2.5','<'))
    {
      $joomla_ver=1;
    }
    if($joomla_ver==1)
    {
      $params1=array();
      $db = JFactory::getDbo();
      $db->setQuery('SELECT params FROM #__plugins WHERE element = '.$db->quote($comp_name));
      $params=$db->loadResult();
      
      if($params!="")
      {
        $tarr=explode("\n",$params);
      }
      if(count($tarr)>0)
      {
        foreach($tarr as $p)
        {
          if($p!="")
          {
            $pos = strpos($p, "=");
            if ($pos === false) {}
            else
            {
              $key=substr($p,0,$pos);
              $val=substr($p,($pos+1),strlen($p));
              $params1[$key]=$val;
            }
          }
        }
      }
      return $params1;
    }
    else
    {
      $db = JFactory::getDbo();
      $db->setQuery('SELECT params FROM #__extensions WHERE element = '.$db->quote($comp_name));
      $params1 = json_decode( $db->loadResult(), true );
      return $params1;
    }
  }
	function checkLicense($lic)
  {
    $checkurl='http://www.softpill.eu/check_complic.php?comp=eratysantanderforvirtuemart&h='.str_ireplace("www.","",$_SERVER['HTTP_HOST']).'&lic='.$lic;
    if (!function_exists('curl_init'))
    {
      $output=@file_get_contents($checkurl);
      if($output==str_ireplace("www.","",$_SERVER['HTTP_HOST']))
      {
        $ok = 1;
      }
    }
    else
    {
      $ch = curl_init();
      curl_setopt($ch, CURLOPT_URL, $checkurl);
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
      $output = curl_exec($ch);
      curl_close($ch);
      if($output==str_ireplace("www.","",$_SERVER['HTTP_HOST']))
      {
        $ok = 1;
      }
    }
  
    
    $application = JFactory::getApplication();
    if(@$ok==1)
    {
      $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
      $this->setParams(array('dchk'=>$chk,'eratysantanderlic'=>$lic),'eratysantanderforvirtuemart');
      $application->enqueueMessage('Thank You for Activating your eRaty Santander - Payment Gateway', 'success');
      return 1;
    }
    else
    {
      $this->setParams(array('eratysantanderlic'=>'','dchk'=>''),'eratysantanderforvirtuemart');
      $application->enqueueMessage('Provided License code is wrong', 'error');
      return 0;
    }
  }
  
	function plgVmConfirmedOrder($cart, $order)
  {
    $params1  = $this->getParams('eratysantanderforvirtuemart');
    $dchk=$params1['dchk'];
    $lic=$params1['eratysantanderlic'];
    $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
    if($dchk!=$chk)
    {
      $application = JFactory::getApplication();
      if($lic=="")
      {
        $application->enqueueMessage('Please input your eRaty Santander - Payment Gateway License Code', 'error');
        $this->setParams(array('eratysantanderlic'=>'','dchk'=>''),'eratysantanderforvirtuemart');
        return;
      }
      else
      {
        $dchk=@$params1['dchk'];
        if($dchk=='')
        {
          if(!$this->checkLicense($lic))
          {
            return;
          }
        }
        else
        {
           $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
           if($chk!=$dchk)//check
           {
             //$this->setParams(array('eratysantanderlic'=>'','dchk'=>''),'eratysantanderforvirtuemart');
             $application->enqueueMessage('Provided License code is wrong', 'error');
             return;
           }
        }
      }
    }
    
		if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
			return null; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}
		$session = JFactory::getSession();
		$this->logInfo('plgVmConfirmedOrder order number: ' . $order['details']['BT']->order_number, 'message');
		if (!class_exists('VirtueMartModelOrders'))
		require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );
		if (!class_exists('VirtueMartModelCurrency'))
		require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php');
		$new_status = '';
		$usrBT = $order['details']['BT'];
		$usrST = isset($order['details']['ST'])?$order['details']['ST']:$order['details']['BT'];
		if (!class_exists('TableVendors'))
		require(JPATH_VM_ADMINISTRATOR . DS . 'table' . DS . 'vendors.php');
		$vendorModel = VmModel::getModel('Vendor');
		$vendorModel->setId(1);
		$vendor = $vendorModel->getVendor();
		$vendorModel->addImages($vendor, 1);
		$this->getPaymentCurrency($method);
		$q = 'SELECT `currency_code_3` FROM `#__virtuemart_currencies` WHERE `virtuemart_currency_id`="' . $method->payment_currency . '" ';
		$db = &JFactory::getDBO();
		$db->setQuery($q);
		$currency_code_3 = $db->loadResult();
		$paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
		$totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total, false), 2);
		
    if (empty($method->eratysantander_user)) {
			vmInfo(JText::_('eRaty Santander Store ID number Missing!!!'));
			return false;
		}
    
    $liczbaSztukTowarow=0;//nr of products
    $post_variables=array();
    
    foreach($order['items'] as $product)
    {
      $liczbaSztukTowarow++;
      //$order_details .= str_ireplace(":","-",$product->order_item_name).':'.$product->product_quantity.':'.number_format(round($product->product_final_price,2),2).':-:'.number_format(round($product->product_final_price,2),2).':'.number_format(round(($product->product_final_price*$product->product_quantity),2),2).':';
      $post_variables['idTowaru'.$liczbaSztukTowarow]=$product->virtuemart_product_id;
      $post_variables['nazwaTowaru'.$liczbaSztukTowarow]=$product->order_item_name;
      $post_variables['wartoscTowaru'.$liczbaSztukTowarow]=round($product->product_final_price,2);
      $post_variables['liczbaSztukTowaru'.$liczbaSztukTowarow]=$product->product_quantity;
      $post_variables['jednostkaTowaru'.$liczbaSztukTowarow]='pieces';
    }
    if(round(($order['details']['BT']->order_shipment+$order['details']['BT']->order_shipment_tax),2)>0)
    {
      $liczbaSztukTowarow++;
      $post_variables['idTowaru'.$liczbaSztukTowarow]=time();
      $post_variables['nazwaTowaru'.$liczbaSztukTowarow]='Shipment Fee';
      $post_variables['wartoscTowaru'.$liczbaSztukTowarow]=round(($order['details']['BT']->order_shipment+$order['details']['BT']->order_shipment_tax),2);
      $post_variables['liczbaSztukTowaru'.$liczbaSztukTowarow]=1;
      $post_variables['jednostkaTowaru'.$liczbaSztukTowarow]='pieces';
		}
		if(round(($order['details']['BT']->order_payment+$order['details']['BT']->order_payment_tax),2)>0)
		{
		  $liczbaSztukTowarow++;
      $post_variables['idTowaru'.$liczbaSztukTowarow]=time();
      $post_variables['nazwaTowaru'.$liczbaSztukTowarow]='Payment Fee';
      $post_variables['wartoscTowaru'.$liczbaSztukTowarow]=round(($order['details']['BT']->order_payment+$order['details']['BT']->order_payment_tax),2);
      $post_variables['liczbaSztukTowaru'.$liczbaSztukTowarow]=1;
      $post_variables['jednostkaTowaru'.$liczbaSztukTowarow]='pieces';
		}
    
    $bill_total=round($order['details']['BT']->order_total,2);
    $post_variables['numerSklepu']=$method->eratysantander_user;
    $post_variables['wartoscTowarow']=$bill_total;//total amount
    $post_variables['typProduktu']='0';
    $post_variables['liczbaSztukTowarow']=$liczbaSztukTowarow;
    $post_variables['nrZamowieniaSklep']=$order['details']['BT']->order_number;
    $post_variables['pesel']='';//customer completes it on the payment page
    $post_variables['imie']=$usrBT->first_name;//first name
    $post_variables['nazwisko']=$usrBT->last_name;//last name
    $post_variables['email']=$usrBT->email;//email
    $post_variables['telKontakt']=$usrBT->phone_1;//phone
    $post_variables['ulica']=$usrBT->address_1;//address 1
    $post_variables['nrDomu']='';//house nr - not used
    $post_variables['nrMieszkania']='';//apartment nr - not used
    $post_variables['miasto']=$usrBT->city;//city
    $post_variables['kodPocz']=$usrBT->zip;//post code
    $post_variables['char']='ISO';
    $post_variables['wniosekZapisany']=JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id.'&on=');//success url
    $post_variables['wniosekAnulowany']=JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginUserPaymentCancel&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id.'&on=');//cancel url
    
    //<input type="image" src="https://www.eraty.pl/images/bannery/zlozwniosek_white.png" border="0" alt="Kontynuuj - Złóż wniosek o kredyt ratalny eRaty Santander Consumer Bank" title="Złóż wniosek o kredyt ratalny eRaty Santander Consumer Bank">
    
    $eRaty_URL='https://wniosek.eraty.pl/formularz/';
    
    $eRaty_button='Przekierowanie do eRaty';

		$html = '<div style="margin: auto; text-align: center;">';
		$html.= "\n".'<form  name="payform" id="payform" action="'.$eRaty_URL.'" method="post">';
	  foreach ($post_variables as $name => $value) {
			$html .= '
      <input type="hidden" name="' . $name . '" value="' . htmlspecialchars ($value) . '" />';
		}
		$html.= '<input type="submit"  value="'.$eRaty_button.'" />';
		$html.= '</form></div>';
		//$html.=htmlentities($strPost);
		$html.= ' <script type="text/javascript">';
    $html.= ' document.payform.submit();';
		$html.= ' </script>';
		
		// Prepare data that should be stored in the database
		$dbValues['order_number'] = $order['details']['BT']->order_number;
		$dbValues['payment_name'] = $this->renderPluginName($method, $order);
		$dbValues['virtuemart_paymentmethod_id'] = $order['details']['BT']->virtuemart_paymentmethod_id;
		$dbValues['cost_per_transaction'] = $method->cost_per_transaction;
		$dbValues['cost_percent_total'] = $method->cost_percent_total;
		$dbValues['payment_currency'] = $method->payment_currency;
		$dbValues['payment_order_total'] = $totalInPaymentCurrency;
		$dbValues['tax_id'] = $method->tax_id;
		
		$this->storePSPluginInternalData($dbValues);
		// 	2 = don't delete the cart, don't send email and don't redirect
		return $this->processConfirmedOrderPaymentResponse(2, $cart, $order, $html, $dbValues['payment_name'], $new_status);
	}
	
	function plgVmOnUserPaymentCancel() {
		if (!class_exists('VirtueMartModelOrders'))
		require( JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php' );

		$order_number = JRequest::getVar('on');
		if (!$order_number)
		return false;
		$db = JFactory::getDBO();
		$query = 'SELECT ' . $this->_tablename . '.`virtuemart_order_id` FROM ' . $this->_tablename . " WHERE  `order_number`= '" . $order_number . "'";

		$db->setQuery($query);
		$virtuemart_order_id = $db->loadResult();

		if (!$virtuemart_order_id) {
			return null;
		}
		$virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);
    $order_number = JRequest::getVar('on', 0);
    $vendorId = 0;
    if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
    	return null;
    }
    if (!$this->selectedThisElement($method->payment_element)) {
    	return false;
    }
    if (!class_exists('VirtueMartCart'))
    require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');
    if (!class_exists('shopFunctionsF'))
    require(JPATH_VM_SITE . DS . 'helpers' . DS . 'shopfunctionsf.php');
    
    $modelOrder = new VirtueMartModelOrders();
	  $modelOrder->remove(array('virtuemart_order_id' => $virtuemart_order_id));
    
    $mainframe = JFactory::getApplication();
    $mainframe->enqueueMessage('Zamowienie anulowane', 'error');
    $mainframe->redirect('index.php?option=com_virtuemart&view=cart');
	}
	
	function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId) {
		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return null; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return false;
		}
		$this->getPaymentCurrency($method);
		$paymentCurrencyId = $method->payment_currency;
	}
	
	function plgVmOnPaymentResponseReceived(&$html) {
	  
    if (!class_exists('VirtueMartCart')) {
			require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');
		}
		if (!class_exists('shopFunctionsF')) {
			require(JPATH_VM_SITE . DS . 'helpers' . DS . 'shopfunctionsf.php');
		}
		if (!class_exists('VirtueMartModelOrders')) {
			require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
		}

		$virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);
		$order_number = JRequest::getString('on', 0);

		if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
			return NULL; // Another method was selected, do nothing
		}
		if (!$this->selectedThisElement($method->payment_element)) {
			return NULL;
		}

		if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number))) {
			return NULL;
		}
		if (!($paymentTable = $this->getDataByOrderId($virtuemart_order_id))) {
			// JError::raiseWarning(500, $db->getErrorMsg());
			return '';
		}
    
    if (!class_exists( 'VmConfig' )) require(JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_virtuemart'.DS.'helpers'.DS.'config.php');
    VmConfig::loadConfig();
    $vm_ver=VmConfig::getInstalledVersion();
    $vm_ver_arr=array('2.0.0','2.0.1','2.0.2','2.0.3','2.0.4','2.0.5');
    if(!in_array($vm_ver,$vm_ver_arr))
    {
		  $order['customer_notified']=1;
		}
		else
		{
		  $order['customer_notified']=0;
    }
		$order['order_status'] = $this->_getPaymentStatus($method, 'OK');
		$order['comments'] = JText::sprintf('Twoje zamowienie %s zostala potwierdzona przez eRaty', $order_number);
		// send the email ONLY if payment has been accepted
		$modelOrder = VmModel::getModel('orders');
		$orderitems = $modelOrder->getOrder($virtuemart_order_id);
		$nb_history = count($orderitems['history']);
		if ($orderitems['history'][$nb_history - 1]->order_status_code != $order['order_status']) {
			$this->logInfo('plgVmOnPaymentResponseReceived, sentOrderConfirmedEmail ' . $order_number, 'message');
			$order['virtuemart_order_id'] = $virtuemart_order_id;
			$order['comments'] = JText::sprintf('Email sent');
			$modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, true);
		}
    
		$payment_name = $this->renderPluginName($method);
		$html = $this->_getPaymentResponseHtml($paymentTable, $payment_name);

		//We delete the old stuff
		// get the correct cart / session
		$cart = VirtueMartCart::getCart();
		$cart->emptyCart();
		return TRUE;
	}
	function _getTablepkeyValue($virtuemart_order_id) {
		$db = JFactory::getDBO();
		$q = 'SELECT ' . $this->_tablepkey . ' FROM `' . $this->_tablename . '` '
		. 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
		$db->setQuery($q);

		if (!($pkey = $db->loadResult())) {
			JError::raiseWarning(500, $db->getErrorMsg());
			return '';
		}
		return $pkey;
	}
	
	function _getPaymentStatus($method, $strStatus) {
		$new_status = '';
		if (strcmp($strStatus, 'OK') == 0) {
			$new_status = $method->status_success;
		}
    elseif (strcmp($strStatus, 'ABORT') == 0) {
			$new_status = $method->status_pending;
		}
    else {
			$new_status = $method->status_canceled;
		}
		return $new_status;
	}
	
	function _getPaymentResponseHtml($paymentTable, $payment_name) {
    $db = &JFactory::getDBO();
    $query="select order_pass from #__virtuemart_orders where order_number='".$paymentTable->order_number."'";
    $db->setQuery($query);
    $result=$db->loadObject();
    
		$html = '<table>' . "\n";
		$html .= '<tr><td>Payment Name</td><td>'.$payment_name.'</td></tr>';
		$html .= '<tr><td>Order Number</td><td>'.$paymentTable->order_number.'</td></tr>';
		
    if(isset($result->order_pass))
    {
      $html .= '<tr><td>View Order</td><td><a href="'.JURI::base().'index.php?option=com_virtuemart&view=orders&layout=details&order_number='.$paymentTable->order_number.'&order_pass='.$result->order_pass.'">Click here</a></td></tr>';
    }
    
    $html .= '</table>
    ' . "\n";
    if(isset($result->order_pass))
    {
      $html .= '
      <script type="text/javascript">
      alert("Dziekuje!");
      window.location="'.JURI::base().'index.php?option=com_virtuemart&view=orders&layout=details&order_number='.$paymentTable->order_number.'&order_pass='.$result->order_pass.'";
      </script>
      ';
    }
		return $html;
	}
	function ArrayExpand($array){
  	$retval = "";
  	for($i = 0; $i < sizeof($array); $i++){
  		$size		= strlen(StripSlashes($array[$i]));
  		$retval	.= $size.StripSlashes($array[$i]);
  	}
  
  	return $retval;
  }

	function plgVmOnPaymentNotification() {
    return;
	}

	function getCosts(VirtueMartCart $cart, $method, $cart_prices) {
		if (preg_match('/%$/', $method->cost_percent_total)) {
			$cost_percent_total = substr($method->cost_percent_total, 0, -1);
		} else {
			$cost_percent_total = $method->cost_percent_total;
		}
		return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
	}
	/**
	 * Check if the payment conditions are fulfilled for this payment method
	 * @author: Valerie Isaksen
	 *
	 * @param $cart_prices: cart prices
	 * @param $payment
	 * @return true: if the conditions are fulfilled, false otherwise
	 *
	 */
	protected function checkConditions($cart, $method, $cart_prices) {
	$this->convert_condition_amount($method);

		$address = (($cart->ST == 0) ? $cart->BT : $cart->ST);

		$amount = $this->getCartAmount($cart_prices);
		$amount_cond = ($amount >= $method->min_amount AND $amount <= $method->max_amount
			OR
			($method->min_amount <= $amount AND ($method->max_amount == 0)));

		$countries = array();
		if (!empty($method->countries)) {
			if (!is_array($method->countries)) {
				$countries[0] = $method->countries;
			} else {
				$countries = $method->countries;
			}
		}
		// probably did not gave his BT:ST address
		if (!is_array($address)) {
			$address = array();
			$address['virtuemart_country_id'] = 0;
		}

		if (!isset($address['virtuemart_country_id'])) {
			$address['virtuemart_country_id'] = 0;
		}
		if (in_array($address['virtuemart_country_id'], $countries) || count($countries) == 0) {
			if ($amount_cond) {
				return TRUE;
			}
		}
    
		return FALSE;
	}
	/**
	 * We must reimplement this triggers for joomla 1.7
	 */
	/**
	 * Create the table for this plugin if it does not yet exist.
	 * This functions checks if the called plugin is active one.
	 * When yes it is calling the standard method to create the tables
	 * @author Valérie Isaksen
	 *
	 */
	function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {

		return $this->onStoreInstallPluginTable($jplugin_id);
	}
	/**
	 * This event is fired after the payment method has been selected. It can be used to store
	 * additional payment info in the cart.
	 *
	 * @author Max Milbers
	 * @author Valérie isaksen
	 *
	 * @param VirtueMartCart $cart: the actual cart
	 * @return null if the payment was not selected, true if the data is valid, error message if the data is not vlaid
	 *
	 */
	public function plgVmOnSelectCheckPayment(VirtueMartCart $cart) {
		return $this->OnSelectCheck($cart);
	}
	/**
	 * plgVmDisplayListFEPayment
	 * This event is fired to display the pluginmethods in the cart (edit shipment/payment) for exampel
	 *
	 * @param object $cart Cart object
	 * @param integer $selected ID of the method selected
	 * @return boolean True on succes, false on failures, null when this plugin was not selected.
	 * On errors, JError::raiseWarning (or JError::raiseError) must be used to set a message.
	 *
	 * @author Valerie Isaksen
	 * @author Max Milbers
	 */
	public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
		return $this->displayListFE($cart, $selected, $htmlIn);
	}
	/*
	 * plgVmonSelectedCalculatePricePayment
	* Calculate the price (value, tax_id) of the selected method
	* It is called by the calculator
	* This function does NOT to be reimplemented. If not reimplemented, then the default values from this function are taken.
	* @author Valerie Isaksen
	* @cart: VirtueMartCart the current cart
	* @cart_prices: array the new cart prices
	* @return null if the method was not selected, false if the shiiping rate is not valid any more, true otherwise
	*
	*
	*/
	public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {
		return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
	}
	/**
	 * plgVmOnCheckAutomaticSelectedPayment
	 * Checks how many plugins are available. If only one, the user will not have the choice. Enter edit_xxx page
	 * The plugin must check first if it is the correct type
	 * @author Valerie Isaksen
	 * @param VirtueMartCart cart: the cart object
	 * @return null if no plugin was found, 0 if more then one plugin was found,  virtuemart_xxx_id if only one plugin is found
	 *
	 */
	function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array()) {
		return $this->onCheckAutomaticSelected($cart, $cart_prices);
	}
	/**
	 * This method is fired when showing the order details in the frontend.
	 * It displays the method-specific data.
	 *
	 * @param integer $order_id The order ID
	 * @return mixed Null for methods that aren't active, text (HTML) otherwise
	 * @author Max Milbers
	 * @author Valerie Isaksen
	 */
	public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
		$this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
	}
	/**
	 * This method is fired when showing when priting an Order
	 * It displays the the payment method-specific data.
	 *
	 * @param integer $_virtuemart_order_id The order ID
	 * @param integer $method_id  method used for this order
	 * @return mixed Null when for payment methods that were not selected, text (HTML) otherwise
	 * @author Valerie Isaksen
	 */
	function plgVmonShowOrderPrintPayment($order_number, $method_id) {
		return $this->onShowOrderPrint($order_number, $method_id);
	}
	function plgVmDeclarePluginParamsPaymentVM3( &$data) {
		return $this->declarePluginParams('payment', $data);
	}
	function plgVmSetOnTablePluginParamsPayment($name, $id, &$table) {
		return $this->setOnTablePluginParams($name, $id, $table);
	}

}
// No closing tag
